from RtpAudioSource import *
from LocalFileAudioSource import *
from InformacastAudioSource import *
from SipClient import *
from SynAppsAudioSource import *
from HTTPAudioSource import *
from PagingAudioSource import *
from UsbAudioSource import *
from SchedulerAudioSource import *


def load_audio_source(sourceType,sourceId,sourceName,sourceVolume,sourceConfig,audioDev,capDev=None):
    # type: (str,int, str, object) -> AudioSource
    if sourceType=="rtp":
        return RtpAudioSource(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    elif sourceType=="barix_radio":
        sourceConfig.update({"url":"http://barix.streamguys.net/barix_hi"})
        return HTTPAudioSource(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    elif sourceType =="syn-apps":
        return SynAppsAudioSource(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    elif sourceType=="local_file":
        return LocalFileAudioSource(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    elif sourceType=="informacast":
        return InformacastAudioSource(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    elif sourceType=="sip":
        if capDev is not None:
            return SipClient(sourceId,sourceName,sourceVolume,sourceConfig,audioDev,capDev)
        return SipClient(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    elif sourceType=="http":
        return HTTPAudioSource(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    elif sourceType=="paging":
        return PagingAudioSource(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    elif sourceType == "usb":
        return UsbAudioSource(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    elif sourceType == "scheduler":
        return SchedulerAudioSource(sourceId,sourceName,sourceVolume,sourceConfig,audioDev)
    else:
        print("Unsupported source type: {}".format(sourceType) )
