import logging
from logging.handlers import RotatingFileHandler

"""
Init logger
"""
def configLogger(name, log_file_path, log_max_size, log_backup_count, debug_mode=False):
    log = logging.getLogger(name)
    if debug_mode:
        log.setLevel(logging.DEBUG)
    else:
        log.setLevel(logging.INFO)
    rotHandler = RotatingFileHandler(log_file_path, maxBytes=log_max_size, backupCount=log_backup_count)
    format1 = logging.Formatter('%(asctime)s  %(levelname)s  %(filename)s:%(lineno)s  %(message)s')
    rotHandler.setFormatter(format1)
    log.addHandler(rotHandler)